From oracle-l-bounce@freelists.org  Tue Aug  3 09:05:47 2004
Return-Path: <oracle-l-bounce@freelists.org>
Received: from air189.startdedicated.com (root@localhost)
 by orafaq.com (8.11.6/8.11.6) with ESMTP id i73E5lw28318
 for <oracle-l@orafaq.com>; Tue, 3 Aug 2004 09:05:47 -0500
X-ClientAddr: 206.53.239.180
Received: from turing.freelists.org (freelists-180.iquest.net [206.53.239.180])
 by air189.startdedicated.com (8.11.6/8.11.6) with ESMTP id i73E5kI28311
 for <oracle-l@orafaq.com>; Tue, 3 Aug 2004 09:05:47 -0500
Received: from localhost (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP
 id E7CFA72C759; Tue,  3 Aug 2004 08:57:04 -0500 (EST)
Received: from turing.freelists.org ([127.0.0.1])
 by localhost (turing [127.0.0.1]) (amavisd-new, port 10024) with ESMTP
 id 26000-15; Tue,  3 Aug 2004 08:57:04 -0500 (EST)
Received: from turing (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP
 id 2588F72C744; Tue,  3 Aug 2004 08:57:04 -0500 (EST)
Received: with ECARTIS (v1.0.0; list oracle-l); Tue, 03 Aug 2004 08:55:41 -0500 (EST)
X-Original-To: oracle-l@freelists.org
Delivered-To: oracle-l@freelists.org
Received: from localhost (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id 3094872C3E4
 for <oracle-l@freelists.org>; Tue,  3 Aug 2004 08:55:40 -0500 (EST)
Received: from turing.freelists.org ([127.0.0.1])
 by localhost (turing [127.0.0.1]) (amavisd-new, port 10024) with ESMTP
 id 24646-22 for <oracle-l@freelists.org>;
 Tue,  3 Aug 2004 08:55:39 -0500 (EST)
Received: from exchange.wgen.net (exchange.wgen.net [216.194.17.194])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id 987D272C3FA
 for <oracle-l@freelists.org>; Tue,  3 Aug 2004 08:55:39 -0500 (EST)
X-MimeOLE: Produced By Microsoft Exchange V6.0.6249.0
content-class: urn:content-classes:message
MIME-Version: 1.0
Content-type: text/plain
Subject: RE: passing several columns into single array using RETURNING clause in java 
Date: Tue, 3 Aug 2004 10:10:01 -0400
Message-ID: <D17DB304A9F42B4787B68861F9DAE61C51D1DE@wgdc02.wgenhq.net>
X-MS-Has-Attach: yes
X-MS-TNEF-Correlator: 
Thread-Topic: passing several columns into single array using RETURNING clause in java 
Thread-Index: AcR5Um46o1/gDLtxRSqA28OU3ZEuWAAEO8dA
From: "Anthony Molinaro" <amolinaro@wgen.net>
To: <oracle-l@freelists.org>
X-Virus-Scanned: by amavisd-new at freelists.org
Content-Transfer-Encoding: 8bit
X-archive-position: 6693
X-ecartis-version: Ecartis v1.0.0
Sender: oracle-l-bounce@freelists.org
Errors-To: oracle-l-bounce@freelists.org
X-original-sender: amolinaro@wgen.net
Precedence: normal
Reply-To: oracle-l@freelists.org
X-list: oracle-l
X-Virus-Scanned: by amavisd-new at freelists.org

Arrg... Outlook has obfuscated a message once again. Here's the code in an attachment.
 - a

-----Original Message-----
From: Tanel Pder [mailto:tanel.poder.003@mail.ee] 
Sent: Tuesday, August 03, 2004 8:07 AM
To: oracle-l@freelists.org
Subject: passing several columns into single array using RETURNING clause in java 


Hi!

How can I pass several column into single array using RETURNING clause in Java?

The statement would have to be following:

update table set status = 'X'
where status 'Y'
returning rowid, col1, col2, col3 into :array;

The update will update several rows at a time...

I need an example, how can I return all those 4 columns to a single array on Java client, not 4 different ones?

Can it be done using JDBC thin drivers?

Tanel.


----------------------------------------------------------------
Please see the official ORACLE-L FAQ: http://www.orafaq.com
----------------------------------------------------------------
To unsubscribe send email to:  oracle-l-request@freelists.org put 'unsubscribe' in the subject line.
--
Archives are at http://www.freelists.org/archives/oracle-l/
FAQ is at http://www.freelists.org/help/fom-serve/cache/1.html
-----------------------------------------------------------------

-- Attached file included as plaintext by Ecartis --
-- File: jdbcdemo.txt
-- Desc: jdbcdemo.txt

/* first create the sql types/routines in the db */

create type emp_obj as object ( row_id varchar2(20), empno number, ename varchar2(10), sal number ); /

create type emp_array as table of emp_obj;
/

create function f_update_emps ( p_deptno number )
return emp_array
is
    l_array emp_array := emp_array();
begin
    update emp
       set sal=9999
     where deptno = p_deptno
    returning emp_obj(rowid,empno,ename,sal) bulk collect into l_array;
    
    return l_array;
end f_update_emps;
/


/* create the jdbc to call f_update_emps and display the output */

import java.lang.*;
import java.sql.*;
import java.io.*;
import oracle.sql.*;
import oracle.jdbc.*;

public class tanel
{
  public static void main( String args[] ) throws IOException, SQLException
  {
    DriverManager.registerDriver( new oracle.jdbc.driver.OracleDriver() );
    Connection conn = DriverManager.getConnection ( "jdbc:oracle:oci:@mydb", "scott", "tiger" );
    conn.setAutoCommit( false );

    Object attributes[] = new Object[4];
    attributes[0] = new String();
    attributes[1] = new Integer(1);
    attributes[2] = new String();
    attributes[3] = new Integer(1);

    Object demo_obj[] = new Object[1];

    demo_obj[0] = new oracle.sql.STRUCT (new oracle.sql.StructDescriptor("EMP_OBJ",conn),conn,attributes);

    oracle.sql.ARRAY demo_array = new oracle.sql.ARRAY (new oracle.sql.ArrayDescriptor("EMP_ARRAY",conn),conn,demo_obj);

    OracleCallableStatement cs = (OracleCallableStatement)conn.prepareCall ("BEGIN ? := F_UPDATE_EMPS(?); END;");

    cs.registerOutParameter (1,OracleTypes.ARRAY,"EMP_ARRAY");
    cs.setInt (2,10); // deptno 10 has 3 rows

    cs.execute();

    oracle.sql.ARRAY results = (oracle.sql.ARRAY)cs.getArray(1);

    ResultSet rs = results.getResultSet();

    while (rs.next()) {

        oracle.sql.STRUCT obj = (STRUCT)rs.getObject(2);

        Object vals[] = obj.getAttributes();

        System.out.println (vals[0] + " " + vals[1] + " " + vals[2] + " " + vals[3]);
    }

    cs.close();
    conn.rollback();
    conn.close();
  }
}


$ javac tanel.java
$ java tanel
AAAUa6AASAAARYKAAG 7782 CLARK 9999
AAAUa6AASAAARYKAAI 7839 KING 9999
AAAUa6AASAAARYKAAN 7934 MILLER 9999


----------------------------------------------------------------
Please see the official ORACLE-L FAQ: http://www.orafaq.com
----------------------------------------------------------------
To unsubscribe send email to:  oracle-l-request@freelists.org
put 'unsubscribe' in the subject line.
--
Archives are at http://www.freelists.org/archives/oracle-l/
FAQ is at http://www.freelists.org/help/fom-serve/cache/1.html
-----------------------------------------------------------------

